"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CRUDService = void 0;
const axios_1 = __importDefault(require("axios"));
class CRUDService {
    constructor(url) {
        this.url = url;
    }
    getAll(params) {
        return __awaiter(this, void 0, void 0, function* () {
            return axios_1.default
                .get(this.url, params)
                .then(response => {
                return response.data;
            })
                .then(data => {
                return data;
            })
                .catch(error => {
                throw new Error(error);
            });
        });
    }
    getOne(index) {
        return __awaiter(this, void 0, void 0, function* () {
            return axios_1.default
                .get(`${this.url}/${index}`)
                .then(response => {
                return response.data;
            })
                .then(data => {
                return data;
            });
        });
    }
    getRandom() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const response = yield this.getAll();
            const randomIndex = Math.floor(Math.random() * response.count);
            const random = (_a = response.results[randomIndex]) === null || _a === void 0 ? void 0 : _a.index;
            if (random) {
                return this.getOne(random);
            }
            else {
                throw new Error('No random index found');
            }
        });
    }
    get(url) {
        return __awaiter(this, void 0, void 0, function* () {
            return axios_1.default
                .get(url)
                .then(response => {
                return response.data;
            })
                .then(data => {
                return data;
            });
        });
    }
}
exports.CRUDService = CRUDService;
