"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpellService = void 0;
const axios_1 = __importDefault(require("axios"));
const CRUDService_1 = require("../CRUDService");
class SpellService extends CRUDService_1.CRUDService {
    constructor() {
        super('https://www.dnd5eapi.co/api/spells');
    }
    getClassSpells(classIndex) {
        return __awaiter(this, void 0, void 0, function* () {
            return axios_1.default
                .get(`https://www.dnd5eapi.co/api/classes/${classIndex}/spells`)
                .then(response => {
                return response.data;
            })
                .then(data => {
                return data;
            });
        });
    }
}
exports.SpellService = SpellService;
